<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1bluetooth_implementations.html">bluetoothImplementations</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z.html">blueZ</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_managed_g_variant_8h_source.html">ManagedGVariant.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a1ab85174e2c371c4903c517d08311f2e"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html#a1ab85174e2c371c4903c517d08311f2e">~ManagedGVariant</a> ()</td></tr>
<tr class="separator:a1ab85174e2c371c4903c517d08311f2e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af4d27b7359139b2c3e0e1e2942d9c022"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html#af4d27b7359139b2c3e0e1e2942d9c022">ManagedGVariant</a> ()</td></tr>
<tr class="separator:af4d27b7359139b2c3e0e1e2942d9c022"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a064266de8f99c19f072ab510e77e3cb5"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html#a064266de8f99c19f072ab510e77e3cb5">ManagedGVariant</a> (GVariant *variant)</td></tr>
<tr class="separator:a064266de8f99c19f072ab510e77e3cb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aabb526248c24794d93e6798f9d59861a"><td class="memItemLeft" align="right" valign="top">GVariant **&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html#aabb526248c24794d93e6798f9d59861a">asOutputParameter</a> ()</td></tr>
<tr class="separator:aabb526248c24794d93e6798f9d59861a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac361d15dd3d233001d0bfbbc11620789"><td class="memItemLeft" align="right" valign="top">GVariant *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html#ac361d15dd3d233001d0bfbbc11620789">get</a> ()</td></tr>
<tr class="separator:ac361d15dd3d233001d0bfbbc11620789"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af628471e3d63b81476ae700dce71fa86"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html#af628471e3d63b81476ae700dce71fa86">dumpToString</a> (bool withAnnotations)</td></tr>
<tr class="separator:af628471e3d63b81476ae700dce71fa86"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f62cb8caf350547384ceee6389fdc7c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html#a1f62cb8caf350547384ceee6389fdc7c">unbox</a> ()</td></tr>
<tr class="separator:a1f62cb8caf350547384ceee6389fdc7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1661a980f28f78923b2b7ae5d57d63a"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html#af1661a980f28f78923b2b7ae5d57d63a">hasValue</a> ()</td></tr>
<tr class="separator:af1661a980f28f78923b2b7ae5d57d63a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ace141167836ee1f037922c0742619ea8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html#ace141167836ee1f037922c0742619ea8">swap</a> (<a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a> &amp;other)</td></tr>
<tr class="separator:ace141167836ee1f037922c0742619ea8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">A wrapper std::shared class for GLib's GVariant objects. This class is not thread safe. This class does not increase the reference count of the variant, but will descrease it in destructor. Floating references are converted to normal ones effectively extending their lifetime to the lifetime of the <code><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a></code> instance. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a1ab85174e2c371c4903c517d08311f2e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1ab85174e2c371c4903c517d08311f2e">&#9670;&nbsp;</a></span>~ManagedGVariant()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant::~ManagedGVariant </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor </p>

</div>
</div>
<a id="af4d27b7359139b2c3e0e1e2942d9c022"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af4d27b7359139b2c3e0e1e2942d9c022">&#9670;&nbsp;</a></span>ManagedGVariant() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant::ManagedGVariant </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Default constructor </p>

</div>
</div>
<a id="a064266de8f99c19f072ab510e77e3cb5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a064266de8f99c19f072ab510e77e3cb5">&#9670;&nbsp;</a></span>ManagedGVariant() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant::ManagedGVariant </td>
          <td>(</td>
          <td class="paramtype">GVariant *&#160;</td>
          <td class="paramname"><em>variant</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">explicit</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">A constructor attaching to an existing <code>GVariant*</code>. If <code>variant</code> is a floating reference, it will be converted to normal one, extending its lifetime to the lifetime of the <code><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a></code> instance.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">variant</td><td>Variant to be attached. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aabb526248c24794d93e6798f9d59861a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aabb526248c24794d93e6798f9d59861a">&#9670;&nbsp;</a></span>asOutputParameter()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">GVariant ** alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant::asOutputParameter </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Get a pointer to the internal <code>GVariant*</code> variable</p>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the internal variable holding the GVariant*. The pointer is valid while the <code><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a></code> instance is valid. </dd></dl>

</div>
</div>
<a id="af628471e3d63b81476ae700dce71fa86"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af628471e3d63b81476ae700dce71fa86">&#9670;&nbsp;</a></span>dumpToString()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant::dumpToString </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>withAnnotations</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Method that dumps the contents of the wrapped variant to a string. Returns "&lt;NULL&gt;" if no variant attached.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">withAnnotations</td><td>true if type information should be added to the output </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A string with the textual representation of the variant </dd></dl>

</div>
</div>
<a id="ac361d15dd3d233001d0bfbbc11620789"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac361d15dd3d233001d0bfbbc11620789">&#9670;&nbsp;</a></span>get()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">GVariant * alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant::get </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Returns a raw <code>GVariant*</code> attached to this object</p>
<dl class="section return"><dt>Returns</dt><dd>A raw <code>GVariant*</code> attached to this object. This pointer is valid as long as this <code><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a></code> instance if valid. </dd></dl>

</div>
</div>
<a id="af1661a980f28f78923b2b7ae5d57d63a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af1661a980f28f78923b2b7ae5d57d63a">&#9670;&nbsp;</a></span>hasValue()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant::hasValue </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">A helper conversion operator to allow checking if object has any variant attached</p>
<dl class="section return"><dt>Returns</dt><dd>true if variant is not null </dd></dl>

</div>
</div>
<a id="ace141167836ee1f037922c0742619ea8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ace141167836ee1f037922c0742619ea8">&#9670;&nbsp;</a></span>swap()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant::swap </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a> &amp;&#160;</td>
          <td class="paramname"><em>other</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Swap the <code>GVariant*</code> values with another instance of <code><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a></code>. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">other</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1f62cb8caf350547384ceee6389fdc7c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1f62cb8caf350547384ceee6389fdc7c">&#9670;&nbsp;</a></span>unbox()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a> alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant::unbox </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">A helper method to extract variant contained in the variant attached to the object. This method is useful when Parsing variant containers where child elements could be boxed into the wrapper variant.</p>
<dl class="section return"><dt>Returns</dt><dd>A variant contained in the variant attached. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/BluetoothImplementations/BlueZ/include/BlueZ/<a class="el" href="_managed_g_variant_8h_source.html">ManagedGVariant.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
